import { type Parser as CSSParser } from "../../syntax/index.js";
import { Numeric } from "./numeric.js";
/**
 * {@link https://drafts.csswg.org/css-values/#percentages}
 *
 * @public
 */
export declare class Percentage extends Numeric<"percentage"> {
    static of(value: number): Percentage;
    protected constructor(value: number);
    scale(factor: number): Percentage;
    equals(value: unknown): value is this;
    toJSON(): Percentage.JSON;
    toString(): string;
}
/**
 * @public
 */
export declare namespace Percentage {
    interface JSON extends Numeric.JSON<"percentage"> {
    }
    function isPercentage(value: unknown): value is Percentage;
    const parse: CSSParser<Percentage>;
}
//# sourceMappingURL=percentage.d.ts.map