import { Flags } from "@siteimprove/alfa-flags";
import type { Hash } from "@siteimprove/alfa-hash";
import { type Parser as CSSParser } from "../../syntax/index.js";
import type { Resolvable } from "../resolvable.js";
import { Value } from "../value.js";
/**
 * {@link https://drafts.csswg.org/css-contain/#contain-property}
 */
declare const CFlags: {
    of: (...flags: import("@siteimprove/alfa-array").Array<0 | 8 | 16 | 1 | 2 | 4 | "size" | "inline-size" | "layout" | "style" | "paint">) => {
        has(flag: 0 | 8 | 16 | 1 | 2 | 4 | "size" | "inline-size" | "layout" | "style" | "paint"): boolean;
        isSet: (flag: 0 | 8 | 16 | 1 | 2 | 4 | "size" | "inline-size" | "layout" | "style" | "paint") => boolean;
        add(...flags: import("@siteimprove/alfa-array").Array<0 | 8 | 16 | 1 | 2 | 4 | "size" | "inline-size" | "layout" | "style" | "paint">): any;
        set: (...flags: import("@siteimprove/alfa-array").Array<0 | 8 | 16 | 1 | 2 | 4 | "size" | "inline-size" | "layout" | "style" | "paint">) => any;
        remove(...flags: import("@siteimprove/alfa-array").Array<0 | 8 | 16 | 1 | 2 | 4 | "size" | "inline-size" | "layout" | "style" | "paint">): any;
        unset: (...flags: import("@siteimprove/alfa-array").Array<0 | 8 | 16 | 1 | 2 | 4 | "size" | "inline-size" | "layout" | "style" | "paint">) => any;
        is(...flags: import("@siteimprove/alfa-array").Array<0 | 8 | 16 | 1 | 2 | 4 | "size" | "inline-size" | "layout" | "style" | "paint">): boolean;
        equals(value: any): boolean;
        equals(value: unknown): value is any;
        toString(): string;
        toJSON(): Flags.JSON<"contain"> & {
            size: boolean;
            "inline-size": boolean;
            layout: boolean;
            style: boolean;
            paint: boolean;
        };
        readonly value: number;
        readonly kind: "contain";
    } & {
        size: boolean;
        "inline-size": boolean;
        layout: boolean;
        style: boolean;
        paint: boolean;
    };
    readonly none: 0;
    readonly empty: {
        has(flag: 0 | 8 | 16 | 1 | 2 | 4 | "size" | "inline-size" | "layout" | "style" | "paint"): boolean;
        isSet: (flag: 0 | 8 | 16 | 1 | 2 | 4 | "size" | "inline-size" | "layout" | "style" | "paint") => boolean;
        add(...flags: import("@siteimprove/alfa-array").Array<0 | 8 | 16 | 1 | 2 | 4 | "size" | "inline-size" | "layout" | "style" | "paint">): any;
        set: (...flags: import("@siteimprove/alfa-array").Array<0 | 8 | 16 | 1 | 2 | 4 | "size" | "inline-size" | "layout" | "style" | "paint">) => any;
        remove(...flags: import("@siteimprove/alfa-array").Array<0 | 8 | 16 | 1 | 2 | 4 | "size" | "inline-size" | "layout" | "style" | "paint">): any;
        unset: (...flags: import("@siteimprove/alfa-array").Array<0 | 8 | 16 | 1 | 2 | 4 | "size" | "inline-size" | "layout" | "style" | "paint">) => any;
        is(...flags: import("@siteimprove/alfa-array").Array<0 | 8 | 16 | 1 | 2 | 4 | "size" | "inline-size" | "layout" | "style" | "paint">): boolean;
        equals(value: any): boolean;
        equals(value: unknown): value is any;
        toString(): string;
        toJSON(): Flags.JSON<"contain"> & {
            size: boolean;
            "inline-size": boolean;
            layout: boolean;
            style: boolean;
            paint: boolean;
        };
        readonly value: number;
        readonly kind: "contain";
    } & {
        size: boolean;
        "inline-size": boolean;
        layout: boolean;
        style: boolean;
        paint: boolean;
    };
    readonly allFlags: [1, 2, 4, 8, 16];
    nameOf: (flag: 8 | 16 | 1 | 2 | 4) => "size" | "inline-size" | "layout" | "style" | "paint";
    reduce: (...flags: import("@siteimprove/alfa-array").Array<number>) => number;
    named: <K extends string, A extends import("@siteimprove/alfa-array").Array<string>>(kind: K, ...flags: A) => {
        [x: string]: any;
    };
    size: 8 | 16 | 1 | 2 | 4;
    "inline-size": 8 | 16 | 1 | 2 | 4;
    layout: 8 | 16 | 1 | 2 | 4;
    style: 8 | 16 | 1 | 2 | 4;
    paint: 8 | 16 | 1 | 2 | 4;
};
type CFlags = ReturnType<(typeof CFlags)["of"]>;
/**
 * @public
 */
export declare class ContainFlags extends Value<"contain-flags", false> implements Resolvable<ContainFlags, never> {
    static of(flags: CFlags): ContainFlags;
    private readonly _flags;
    protected constructor(flags: CFlags);
    get size(): boolean;
    get inlineSize(): boolean;
    get layout(): boolean;
    get style(): boolean;
    get paint(): boolean;
    resolve(): ContainFlags;
    equals(value: unknown): value is this;
    hash(hash: Hash): void;
    toJSON(): ContainFlags.JSON;
    toString(): string;
}
/**
 * @public
 */
export declare namespace ContainFlags {
    interface JSON extends Value.JSON<"contain-flags"> {
        size: boolean;
        inlineSize: boolean;
        layout: boolean;
        style: boolean;
        paint: boolean;
    }
    function isContainFlags(value: unknown): value is ContainFlags;
    const parse: CSSParser<ContainFlags>;
}
export {};
//# sourceMappingURL=contain.d.ts.map