import type { Hash } from "@siteimprove/alfa-hash";
import { type Parser as CSSParser } from "../../syntax/index.js";
import { Keyword } from "../textual/keyword.js";
import { Length } from "../numeric/index.js";
import type { Resolvable } from "../resolvable.js";
import { Value } from "../value.js";
import { BasicShape } from "./basic-shape.js";
/**
 * {@link https://drafts.fxtf.org/css-masking/#funcdef-clip-rect}
 *
 * @public
 * @deprecated Deprecated as of CSS Masking Module Level 1
 */
export declare class Rectangle<O extends Length | Rectangle.Auto = Length | Rectangle.Auto> extends BasicShape<"rectangle", Value.HasCalculation<[O, O, O, O]>> implements Resolvable<Rectangle.Canonical, Rectangle.Resolver> {
    static of<O extends Length | Rectangle.Auto = Length | Rectangle.Auto>(top: O, right: O, bottom: O, left: O): Rectangle<O>;
    readonly _top: O;
    readonly _right: O;
    readonly _bottom: O;
    readonly _left: O;
    protected constructor(top: O, right: O, bottom: O, left: O);
    get top(): O;
    get right(): O;
    get bottom(): O;
    get left(): O;
    resolve(resolver: Rectangle.Resolver): Rectangle.Canonical;
    equals(value: Rectangle): boolean;
    equals(value: unknown): value is this;
    hash(hash: Hash): void;
    toJSON(): Rectangle.JSON;
    toString(): string;
}
/**
 * @public
 * @deprecated Deprecated as of CSS Masking Module Level 1
 */
export declare namespace Rectangle {
    type Canonical = Rectangle<Length.Canonical | Auto>;
    type Auto = Keyword<"auto">;
    interface JSON extends BasicShape.JSON<"rectangle"> {
        top: Length.JSON | Keyword.JSON;
        right: Length.JSON | Keyword.JSON;
        bottom: Length.JSON | Keyword.JSON;
        left: Length.JSON | Keyword.JSON;
    }
    type Resolver = Length.Resolver;
    function isRectangle(value: unknown): value is Rectangle;
    const parse: CSSParser<Rectangle>;
}
//# sourceMappingURL=rectangle.d.ts.map