import { Predicate } from "@siteimprove/alfa-predicate";
import { type Parser as CSSParser } from "../../syntax/index.js";
import type { Resolvable } from "../resolvable.js";
import { Ident } from "./ident.js";
/**
 * {@link https://developer.mozilla.org/en-US/docs/Web/CSS/custom-ident}
 *
 * @public
 */
export declare class CustomIdent extends Ident<"custom-ident"> implements Resolvable<CustomIdent, never> {
    static of(value: string): CustomIdent;
    protected constructor(value: string);
    equals(value: unknown): value is this;
}
/**
 * @public
 */
export declare namespace CustomIdent {
    function isCustomIdent(value: unknown): value is CustomIdent;
    function parse(predicate?: Predicate<string>): CSSParser<CustomIdent>;
}
//# sourceMappingURL=custom-ident.d.ts.map