import type { Hash } from "@siteimprove/alfa-hash";
import { type Parser as CSSParser } from "../../syntax/index.js";
import type { Resolvable } from "../resolvable.js";
import { Value } from "../value.js";
/**
 * {@link https://drafts.csswg.org/css-values/#strings}
 *
 * @public
 */
export declare class String extends Value<"string", false> implements Resolvable<String, never> {
    static of(value: string): String;
    private readonly _value;
    protected constructor(value: string);
    get value(): string;
    resolve(): String;
    equals(value: unknown): value is this;
    hash(hash: Hash): void;
    toJSON(): String.JSON;
    toString(): string;
}
/**
 * @public
 */
export declare namespace String {
    interface JSON extends Value.JSON<"string"> {
        value: string;
    }
    function isString(value: unknown): value is String;
    const parse: CSSParser<String>;
}
//# sourceMappingURL=string.d.ts.map