import type { Hash } from "@siteimprove/alfa-hash";
import { Parser } from "@siteimprove/alfa-parser";
import { Number } from "../numeric/index.js";
import type { Resolvable } from "../resolvable.js";
import { Function } from "./function.js";
/**
 * @public
 */
export declare class Matrix extends Function<"matrix", false> implements Resolvable<Matrix.Canonical, never> {
    static of(...values: Matrix.Values<Number>): Matrix;
    private readonly _values;
    protected constructor(values: Matrix.Values<Number.Canonical>);
    get values(): Matrix.Values<Number.Canonical>;
    resolve(): Matrix;
    equals(value: unknown): value is this;
    hash(hash: Hash): void;
    toJSON(): Matrix.JSON;
    toString(): string;
}
/**
 * @public
 */
export declare namespace Matrix {
    type Canonical = Matrix;
    interface JSON extends Function.JSON<"matrix"> {
        values: Values<Number.Fixed.JSON>;
    }
    type Values<T> = [
        [
            T,
            T,
            T,
            T
        ],
        [
            T,
            T,
            T,
            T
        ],
        [
            T,
            T,
            T,
            T
        ],
        [
            T,
            T,
            T,
            T
        ]
    ];
    function isMatrix(value: unknown): value is Matrix;
    const parse: Parser<import("@siteimprove/alfa-slice").Slice<import("../../syntax/token.js").Token>, Matrix, string, []>;
}
//# sourceMappingURL=matrix.d.ts.map